package org.lyj.node;

import java.time.Duration;

import org.knime.core.node.InvalidSettingsException;
import org.knime.core.node.NodeSettingsRO;
import org.knime.core.node.NodeSettingsWO;

public final class ParametersConfig {
	static final String CFG_URL = "url";
	
	/*
	 * 2017年12月21日13:56:21
	 * 添加jar包获取
	 * TimeOut
	 */
//	private String m_location;//Jar包路径
	
	
	private Duration m_connectTimeout;
	
	private String m_class;// 主类 com.knowlegene.kw.deptgroup.One
	private String m_sparkUrl;// spark服务器地址
	
	/*
	 * 2017年12月21日15:53:45
	 * SparkUrl可以解析
	 */
	//private String m_sparkMaster;// master的地址
	private String m_name;// 类名称 One_ + date
	private String m_driverMemory;// driver内存大小
	private String m_executorCores;// executor的核数
	private String m_executorMemory;// executor的内存大小
	private String m_config_serializer;// config 1
										// 序列化方式，可以不配置，使用默认；或配置为"spark.serializer=org.apache.spark.serializer.KryoSerializer"
	private String m_config_Heartbeat;// config 2
										// 心跳，可以不配置，使用默认；或配置为"spark.executor.heartbeatInterval=500s"
	// private String m_config_three;//config 3
	
	
	private String m_jarUrl;// jar路径

	/*
	 * 额外添加的参数 Username Password 通过SCP client 登录服务器使用
	 */
	private String m_username;// 用户名称
	private String m_password;// 用户密码
	
	
	/*
	 * 2018年1月5日17:40:04
	 * 添加第二个输入
	 */
	private String m_inputRelation;//关系数据输入
	
	private String m_inputNode;//节点数据输入
	
	private String m_inputOrg;//投资机构数据输入
	
	private String m_inputBfTim;//上次运行日期
	
	private String m_inputNowTim;//本次运行日期
	
	private String m_outputRelation;//系信息
	
	private String m_outputCompany;//系成员
	
	private String m_outputUBO;//UBO
	
	
	/*
	 *模型参数 
	 * 
	 **/
	
	private String m_menCountMin;//最小成员数---2
	private String m_capitalNum;//集团母公司对外投资数---5
	private String m_totalCapital;//集团母公司认定合计注册资本---100000000
	private String m_capitalRate;//控制图，最小投资比例---10
	private String m_groupCapital;//集团母公司注册资本最小值---500000000
	
	

	public String getM_menCountMin() {
		return m_menCountMin;
	}

	public void setM_menCountMin(String m_menCountMin) {
		this.m_menCountMin = m_menCountMin;
	}

	public String getM_capitalNum() {
		return m_capitalNum;
	}

	public void setM_capitalNum(String m_capitalNum) {
		this.m_capitalNum = m_capitalNum;
	}

	public String getM_totalCapital() {
		return m_totalCapital;
	}

	public void setM_totalCapital(String m_totalCapital) {
		this.m_totalCapital = m_totalCapital;
	}

	public String getM_capitalRate() {
		return m_capitalRate;
	}

	public void setM_capitalRate(String m_capitalRate) {
		this.m_capitalRate = m_capitalRate;
	}

	public String getM_groupCapital() {
		return m_groupCapital;
	}

	public void setM_groupCapital(String m_groupCapital) {
		this.m_groupCapital = m_groupCapital;
	}

	public String getM_inputRelation() {
		return m_inputRelation;
	}

	public void setM_inputRelation(String m_inputRelation) {
		this.m_inputRelation = m_inputRelation;
	}

	public String getM_inputNode() {
		return m_inputNode;
	}

	public void setM_inputNode(String m_inputNode) {
		this.m_inputNode = m_inputNode;
	}

	public String getM_inputOrg() {
		return m_inputOrg;
	}

	public void setM_inputOrg(String m_inputOrg) {
		this.m_inputOrg = m_inputOrg;
	}

	public String getM_inputBfTim() {
		return m_inputBfTim;
	}

	public void setM_inputBfTim(String m_inputBfTim) {
		this.m_inputBfTim = m_inputBfTim;
	}

	public String getM_inputNowTim() {
		return m_inputNowTim;
	}

	public void setM_inputNowTim(String m_inputNowTim) {
		this.m_inputNowTim = m_inputNowTim;
	}

	public String getM_outputRelation() {
		return m_outputRelation;
	}

	public void setM_outputRelation(String m_outputRelation) {
		this.m_outputRelation = m_outputRelation;
	}

	public String getM_outputCompany() {
		return m_outputCompany;
	}

	public void setM_outputCompany(String m_outputCompany) {
		this.m_outputCompany = m_outputCompany;
	}

	public String getM_OutputUBO() {
		return m_outputUBO;
	}

	public void setM_OutputUBO(String m_OutputUBO) {
		this.m_outputUBO = m_OutputUBO;
	}

	public String getM_username() {
		return m_username;
	}

	public void setM_username(String m_username) {
		this.m_username = m_username;
	}

	public String getM_password() {
		return m_password;
	}

	public void setM_password(String m_password) {
		this.m_password = m_password;
	}

	public String getM_jarUrl() {
		return m_jarUrl;
	}

	public void setM_jarUrl(String m_jarUrl) {
		this.m_jarUrl = m_jarUrl;
	}

	public String getM_driverMemory() {
		return m_driverMemory;
	}

	public void setM_driverMemory(String m_driverMemory) {
		this.m_driverMemory = m_driverMemory;
	}

	public String getM_name() {
		return m_name;
	}

	public void setM_name(String m_name) {
		this.m_name = m_name;
	}

	public String getM_class() {
		return m_class;
	}

	public void setM_class(String m_class) {
		this.m_class = m_class;
	}

	public String getM_executorCores() {
		return m_executorCores;
	}

	public void setM_executorCores(String m_executorCores) {
		this.m_executorCores = m_executorCores;
	}

	public String getM_executorMemory() {
		return m_executorMemory;
	}

	public void setM_executorMemory(String m_executorMemory) {
		this.m_executorMemory = m_executorMemory;
	}

	// public String getM_config_three() {
	// return m_config_three;
	// }
	//
	// public void setM_config_three(String m_config_three) {
	// this.m_config_three = m_config_three;
	// }

	public String getM_config_serializer() {
		return m_config_serializer;
	}

	public void setM_config_serializer(String m_config_serializer) {
		this.m_config_serializer = m_config_serializer;
	}

	public String getM_config_Heartbeat() {
		return m_config_Heartbeat;
	}

	public void setM_config_Heartbeat(String m_config_Heartbeat) {
		this.m_config_Heartbeat = m_config_Heartbeat;
	}

	public String getM_sparkUrl() {
		return m_sparkUrl;
	}

	public void setM_sparkUrl(String m_sparkUrl) {
		this.m_sparkUrl = m_sparkUrl;
	}
	
	public Duration getM_connectTimeout() {
		return m_connectTimeout;
	}

	public void setM_connectTimeout(Duration m_connectTimeout) {
		this.m_connectTimeout = m_connectTimeout;
	}
	
	public ParametersConfig() {
		m_class = "com.knowlegene.kw.graph.job.ActionJob";
		m_sparkUrl = "spark://192.168.20.40:7077";
		//m_sparkMaster = "";
		m_name = "";
		m_driverMemory = "2";
		m_executorCores = "3";
		m_executorMemory = "45";
		m_config_serializer = "org.apache.spark.serializer.KryoSerializer";
		m_config_Heartbeat = "5";
		m_jarUrl = "";
		
		/*
		 * 2018年1月5日17:40:40
		 * 第二个输入
		 */
		
		m_username = "hadoop";
		m_password = "123456";
		
		m_inputRelation = "e_mart.E_D07_BUS_REL_CR";//关系数据输入
		
		m_inputNode = "e_mart.E_D07_BUS_NODE_CR";//节点数据输入
		
		m_inputOrg = "b_mart.B_C10_INV_GRT_AGC_CR";//投资机构数据输入
		
		m_inputBfTim = "2018-09-29";//上次运行日期
		
		m_inputNowTim = "2018-10-22";//本次运行日期
		
		m_outputRelation = "e_mart.E_D08_DEPT_INFO";//系信息
		
		m_outputCompany = "e_mart.E_D08_DEPT_MEMBER_INFO";//系成员
		
		m_outputUBO = "e_mart.E_D08_ECONOMIC_INFO";//UBO
		
		m_menCountMin = "2";//最小成员数---2
		m_capitalNum = "5";//集团母公司对外投资数---5
		m_totalCapital = "100000000";//集团母公司认定合计注册资本---
		m_capitalRate = "10";//控制图，最小投资比例---10
		m_groupCapital = "500000000";//集团母公司注册资本最小值---
	}

	// ---------------分割线---------------
	public void loadSettingInDialog(final NodeSettingsRO settings) {
		m_sparkUrl = settings.getString("m_sparkUrl", m_sparkUrl);
		//m_sparkMaster = settings.getString("m_sparkMaster", m_sparkMaster);
		m_class = settings.getString("m_class", m_class);
		m_name = settings.getString("m_name", m_name);
		m_executorCores = settings.getString("m_executorCores", m_executorCores);
		m_driverMemory = settings.getString("m_driverMemory", m_driverMemory);
		m_executorMemory = settings.getString("m_executorMemory", m_executorMemory);
		m_config_serializer = settings.getString("m_config_serializer", m_config_serializer);
		m_config_Heartbeat = settings.getString("m_config_Heartbeat", m_config_Heartbeat);
		// m_config_three = settings.getString("m_config_three",
		// m_config_three);
		m_jarUrl = settings.getString("m_jarUrl", m_jarUrl);
		
		/*
		 * 2018年1月5日17:41:49
		 * 添加第二输入
		 */
        m_inputRelation = settings.getString("m_inputRelation",m_inputRelation);//关系数据输入
		
		m_inputNode = settings.getString("m_inputNode",m_inputNode);//节点数据输入
		
		m_inputOrg = settings.getString("m_inputOrg",m_inputOrg);//投资机构数据输入
		
		m_inputBfTim = settings.getString("m_inputBfTim",m_inputBfTim);//上次运行日期
		
		m_inputNowTim = settings.getString("m_inputNowTim",m_inputNowTim);//本次运行日期
		
		m_outputRelation = settings.getString("m_outputRelation",m_outputRelation);//系信息
		
		m_outputCompany = settings.getString("m_outputCompany",m_outputCompany);//系成员
		
		m_outputUBO = settings.getString("m_outputUBO",m_outputUBO);//UBO
		
		m_menCountMin = settings.getString("m_menCountMin",m_menCountMin);//最小成员数---2
		m_capitalNum = settings.getString("m_capitalNum",m_capitalNum);//集团母公司对外投资数---5
		m_totalCapital = settings.getString("m_totalCapital",m_totalCapital);//集团母公司认定合计注册资本---
		m_capitalRate = settings.getString("m_capitalRate",m_capitalRate);//控制图，最小投资比例---10
		m_groupCapital = settings.getString("m_groupCapital",m_groupCapital);//集团母公司注册资本最小值---
		
		/*
		 * 2017年12月20日15:20:23
		 * 添加username 和 password
		 */
		m_username = settings.getString("m_username",m_username);
		/*try {
			m_password = settings.getPassword("m_password", m_password);
		} catch (InvalidSettingsException e) {
			e.printStackTrace();
		}*/
		m_password = settings.getString("m_password",m_password);
		
		/*
		 * 2017年12月21日13:58:47
		 * 添加jar包选择
		 */
//		m_location = settings.getString(CFG_URL,null);
		
		/*
		 * 2017年12月21日14:05:39
		 * 添加Timeout
		 */
		 try {
	            m_connectTimeout = Duration.ofSeconds(settings.getInt("connectTimeoutInSeconds"));
	        } catch (InvalidSettingsException ex) {
	            m_connectTimeout = null; // use default value
	        }
	}

	public void loadSettingInModel(final NodeSettingsRO settings) throws InvalidSettingsException {
		m_sparkUrl = settings.getString("m_sparkUrl");
		//m_sparkMaster = settings.getString("m_sparkMaster");
		m_class = settings.getString("m_class");
		m_name = settings.getString("m_name");
		m_executorCores = settings.getString("m_executorCores");
		m_driverMemory = settings.getString("m_driverMemory");
		m_executorMemory = settings.getString("m_executorMemory");
		m_config_serializer = settings.getString("m_config_serializer");
		m_config_Heartbeat = settings.getString("m_config_Heartbeat");
		// m_config_three = settings.getString("m_config_three");
		m_jarUrl = settings.getString("m_jarUrl");
		
		/*
		 * 2018年1月5日17:42:54
		 * 添加第二个输入
		 */
		
		m_inputRelation = settings.getString("m_inputRelation");//关系数据输入
		
		m_inputNode = settings.getString("m_inputNode");//节点数据输入
		
		m_inputOrg = settings.getString("m_inputOrg");//投资机构数据输入
		
		m_inputBfTim = settings.getString("m_inputBfTim");//上次运行日期
		
		m_inputNowTim = settings.getString("m_inputNowTim");//本次运行日期
		
		m_outputRelation = settings.getString("m_outputRelation");//系信息
		
		m_outputCompany = settings.getString("m_outputCompany");//系成员
		
		m_outputUBO = settings.getString("m_outputUBO");//UBO
		
		m_menCountMin = settings.getString("m_menCountMin");//最小成员数---2
		m_capitalNum = settings.getString("m_capitalNum");//集团母公司对外投资数---5
		m_totalCapital = settings.getString("m_totalCapital");//集团母公司认定合计注册资本---
		m_capitalRate = settings.getString("m_capitalRate");//控制图，最小投资比例---10
		m_groupCapital = settings.getString("m_groupCapital");//集团母公司注册资本最小值---
		
		/*
		 * 2017年12月20日15:22:12
		 */
		m_username = settings.getString("m_username");
		m_password = settings.getString("m_password");
		
		/*
		 * 2017年12月21日14:06:20
		 * 添加Timeout
		 */
		 try {
	            m_connectTimeout = Duration.ofSeconds(settings.getInt("connectTimeoutInSeconds"));
	        } catch (InvalidSettingsException ex) {
	            m_connectTimeout = null; // use default value
	        }
	}

	public void saveSettingsTo(final NodeSettingsWO settings) {
		if (m_sparkUrl != null) {
			settings.addString("m_sparkUrl", m_sparkUrl.toString());
		}

		if (m_class != null) {
			settings.addString("m_class", m_class.toString());
		}
		if (m_name != null) {
			settings.addString("m_name", m_name.toString());
		}
		if (m_executorCores != null) {
			settings.addString("m_executorCores", m_executorCores.toString());
		}
		if (m_driverMemory != null) {
			settings.addString("m_driverMemory", m_driverMemory.toString());
		}
		if (m_executorMemory != null) {
			settings.addString("m_executorMemory", m_executorMemory.toString());
		}
		if (m_config_serializer != null) {
			settings.addString("m_config_serializer", m_config_serializer.toString());
		}
		if (m_config_Heartbeat != null) {
			settings.addString("m_config_Heartbeat", m_config_Heartbeat.toString());
		}
		if (m_jarUrl != null) {
			settings.addString("m_jarUrl", m_jarUrl.toString());
		}
	
		if (m_inputRelation != null) {
			settings.addString("m_inputRelation", m_inputRelation.toString());
		}
		
		if (m_inputNode != null) {
			settings.addString("m_inputNode", m_inputNode.toString());
		}
		if (m_inputOrg != null) {
			settings.addString("m_inputOrg", m_inputOrg.toString());
		}
		if (m_inputBfTim != null) {
			settings.addString("m_inputBfTim", m_inputBfTim.toString());
		}
		if (m_inputNowTim != null) {
			settings.addString("m_inputNowTim", m_inputNowTim.toString());
		}
		if (m_outputRelation != null) {
			settings.addString("m_outputRelation", m_outputRelation.toString());
		}
		if (m_outputCompany != null) {
			settings.addString("m_outputCompany", m_outputCompany.toString());
		}
		if (m_outputUBO != null) {
			settings.addString("m_outputUBO", m_outputUBO.toString());
		}
		
		if (m_menCountMin != null) {
			settings.addString("m_menCountMin", m_menCountMin.toString());
		}
		if (m_capitalNum != null) {
			settings.addString("m_capitalNum", m_capitalNum.toString());
		}
		if (m_totalCapital != null) {
			settings.addString("m_totalCapital", m_totalCapital.toString());
		}
		if (m_capitalRate != null) {
			settings.addString("m_capitalRate", m_capitalRate.toString());
		}
		if (m_groupCapital != null) {
			settings.addString("m_groupCapital", m_groupCapital.toString());
		}
		if (m_username != null) {
			settings.addString("m_username", m_username.toString());
		}
		if (m_password != null) {
			settings.addString("m_password", m_password.toString());
		}
		if (m_connectTimeout != null) {
            settings.addInt("connectTimeoutInSeconds", (int) (m_connectTimeout.toMillis() / 1000));
        }
	}

}
