package org.lyj.node;

import org.knime.core.node.NodeView;

/**
 * <code>NodeView</code> for the "ParametersInput" Node.
 * 参数输入节点
 *
 * @author YoGa
 */
public class ParametersInputNodeView extends NodeView<ParametersInputNodeModel> {

    /**
     * Creates a new view.
     * 
     * @param nodeModel The model (class: {@link ParametersInputNodeModel})
     */
    protected ParametersInputNodeView(final ParametersInputNodeModel nodeModel) {
        super(nodeModel);


    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected void modelChanged() {

        // update the view.
        ParametersInputNodeModel nodeModel = 
            (ParametersInputNodeModel)getNodeModel();
        assert nodeModel != null;
        
        // be aware of a possibly not executed nodeModel! The data you retrieve
        // from your nodemodel could be null, emtpy, or invalid in any kind.
        
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected void onClose() {
    
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected void onOpen() {

    }

}

