package org.lyj.node;

import org.knime.core.node.NodeDialogPane;
import org.knime.core.node.NodeFactory;
import org.knime.core.node.NodeView;

/**
 * <code>NodeFactory</code> for the "SubmitToSpark" Node.
 * Sparkύִнڵ
 *
 * @author YoGa
 */
public class SubmitToSparkNodeFactory 
        extends NodeFactory<SubmitToSparkNodeModel> {

    /**
     * {@inheritDoc}
     */
    @Override
    public SubmitToSparkNodeModel createNodeModel() {
        return new SubmitToSparkNodeModel();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public int getNrNodeViews() {
        return 0;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public NodeView<SubmitToSparkNodeModel> createNodeView(final int viewIndex,
            final SubmitToSparkNodeModel nodeModel) {
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean hasDialog() {
        return true;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public NodeDialogPane createNodeDialogPane() {
        return new SubmitToSparkNodeDialog();
    }

}

