package org.lyj.node;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.HashMap;
import java.util.Set;

import org.knime.core.data.DataCell;
import org.knime.core.data.DataColumnSpec;
import org.knime.core.data.DataColumnSpecCreator;
import org.knime.core.data.DataRow;
import org.knime.core.data.DataTableSpec;
import org.knime.core.data.RowKey;
import org.knime.core.data.def.DefaultRow;
import org.knime.core.data.def.StringCell;
import org.knime.core.node.BufferedDataContainer;
import org.knime.core.node.BufferedDataTable;
import org.knime.core.node.CanceledExecutionException;
import org.knime.core.node.ExecutionContext;
import org.knime.core.node.ExecutionMonitor;
import org.knime.core.node.InvalidSettingsException;
import org.knime.core.node.NodeLogger;
import org.knime.core.node.NodeModel;
import org.knime.core.node.NodeSettingsRO;
import org.knime.core.node.NodeSettingsWO;
import org.lyj.conn.ConnectionLinux;

/**
 * This is the model implementation of SubmitToSpark. Sparkύִнڵ
 *
 * @author YoGa
 */
public class SubmitToSparkNodeModel extends NodeModel {

	// the logger instance
	private static final NodeLogger logger = NodeLogger.getLogger(SubmitToSparkNodeModel.class);

	/**
	 * the settings key which is used to retrieve and store the settings (from
	 * the dialog or from a settings file) (package visibility to be usable from
	 * the dialog).
	 */
	// static final String CFGKEY_COUNT = "Count";

	/** initial default count value. */
	// static final int DEFAULT_COUNT = 100;

	// example value: the models count variable filled from the dialog
	// and used in the models execution method. The default components of the
	// dialog work with "SettingsModels".
	// private final SettingsModelIntegerBounded m_count =
	// new SettingsModelIntegerBounded(SubmitToSparkNodeModel.CFGKEY_COUNT,
	// SubmitToSparkNodeModel.DEFAULT_COUNT,
	// Integer.MIN_VALUE, Integer.MAX_VALUE);

	/**
	 * Constructor for the node model.
	 */
	protected SubmitToSparkNodeModel() {
		/*
		 * һ룬һ 
		 */
		super(1, 1);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected BufferedDataTable[] execute(final BufferedDataTable[] inData, final ExecutionContext exec)
			throws Exception {

		System.out.println("----------START----------");
		// TODO 1ȡϸڵύĲ
		logger.info("ȡϸڵύĲ...");
		BufferedDataTable in = inData[0];
		// DataRow dataRow = in.getDataTable(null, null);
		// BufferedDataContainer bufferedDataContainer =
		// exec.createDataContainer(in.getDataTableSpec());
		// bufferedDataContainer.
		/*
		 * Integer tableId = in.getBufferedTableId();
		 * System.out.println("tableId is : "+tableId);
		 */

		// in.getDataTable(tblRep, tableID)
		// in.getDataTableSpec()
		System.out.println("---getSpec() from datatable---");
		DataTableSpec inputSpec = in.getDataTableSpec();
		System.out.println("---get cloumns info---");

		// System.out.println("SparkUrl:"+inputSpec.getColumnSpec("SparkUrl"));
		// System.out.println("inputSpec.getColumnSpec('column1')" +
		// inputSpec.getColumnSpec("column1"));
		// System.out.println("inputSpec.getColumnSpec(0)" +
		// inputSpec.getColumnSpec(0));
		// System.out.println("1 cloumn = " +
		// inputSpec.getColumnSpec("column1").getDomain().getValues());
		// inputSpec.getColumnNames();

		String[] a = inputSpec.getColumnNames();
		HashMap<String, String> dataMap = new HashMap<String, String>();
		// System.out.println("a[0]" + a[0] + "/a[1]" + a[1]);
		for (int i = 0; i < a.length; i++) {
			Set<DataCell> set = inputSpec.getColumnSpec(a[i]).getDomain().getValues();

			for (DataCell dataCell : set) {
				// System.out.println("dataCell = " + dataCell);
				String value = dataCell.toString();
				System.out.println(a[i] + " = " + value);
				dataMap.put(a[i], value);
			}

		}
		System.out.println("-------for--(DataCell)----");
		/*
		 * for (Iterator iterator = set.iterator(); iterator.hasNext();) {
		 * System.out.println("in for"); String value = (String)
		 * iterator.next(); System.out.println("/"+value); }
		 */

		// in.getDataTableSpec().getColumnNames()
		System.out.println("----------");
		// String sparkUrl = in.getSpec().getColumnSpec("SparkUrl").toString();
		// System.out.println("------"+sparkUrl);

		// TODO 2ύjarSpark
		logger.info("ʼύSpark...");

		// TODO ȡҪĲhostname port ʹscpʱǷҪusername password
		/* System.out.println("---ȡurl---"); */
		// System.out.println(dataMap.get("SparkUrl"));
		/*
		 * ȡUrl---SparkUrl
		 */
		String hostUrl = dataMap.get("SparkUrl");
		/*if (!hostUrl.startsWith("spark") | !hostUrl.startsWith("http") | !hostUrl.startsWith("https")
				| !hostUrl.startsWith("stfp") | !hostUrl.startsWith("ftp")) {
			hostUrl = "http://" + hostUrl;
		}else{
			
		}*/
		/* hostUrl = hostUrl.replaceFirst("spark", "http"); */
		hostUrl = hostUrl.replaceAll("spark", "http");
		URL url = new URL(hostUrl);

		System.out.println("url= "+ url);
		
		String host = url.getHost();//ȡhost
		int port = url.getPort();//ȡport

		System.out.println("host:" + host);
		System.out.println("port:" + port);

		System.out.println("connecting url " + host + " ...");
		
		// TODO ӿڱ޸ Ϊ22 ύ
		port = 22;
		
		
		// TODO û
		/*
		 * 2017122016:05:54
		 */
		System.out.println("---û");
		String username = dataMap.get("UserName");
		String password = dataMap.get("PassWord");
		/*
		 * 
		 */
		System.out.println("---");
		String localUrl = dataMap.get("JarUrl");
		String remoteUrl = "/home/"+username+"/jar";	//Զ̶ϴjarλ 
		
		
		/*
		 * 2017122813:07:53
		 * jarurlȡļƺĿ¼·
		 */
		String path = localUrl;
		String dir = null;
		String filename = null;
		try {
			String ss[] = path.split("\\/");
			filename = ss[ss.length-1];
			dir = path.replaceAll("/"+filename, "");
		} catch (Exception e) {
			String ss[] = path.split("\\\\");
			filename = ss[ss.length-1];
			dir = path.replaceAll("\\\\"+filename, "");
		}
		
		
		/*
		 * 2017122716:17:55
		 * 汨
		 * Unable to load node with ID suffix 2 into workflow, skipping it: com/jcraft/jsch/JSchException
		 * State has changed from CONFIGURED to EXECUTED
		 */
		System.out.println("---Connection");
		//ConnectionLinux connectionLinux = new ConnectionLinux();//linux 
//		ConnectionLinux connectionLinux = new ConnectionLinux() ;
		
		/*
		 * 2017122813:08:55
		 * ޸ϴjar
		 */
		// TODO Ӷ˿Ϊ22 ж˿Ϊ˿ 
		ConnectionLinux connectionLinux = new ConnectionLinux(host,username, password,port);
		connectionLinux.putFiletoLinux(dir,filename, "/home/"+username+"/jar");
		
		System.out.println("---ӷ jarļϴһȡ");
		/*
		 * 2017122717:29:18
		 * ϴ
		 */
		
		
		// ӷ jarļϴһȡ
		/*
		 * ϴļʧ
		 */
		connectionLinux.putFile(username, password, host, port, localUrl, remoteUrl);

//		String uploadjar_command = "";
//		Map<String, String> uploadjarmap = connectionLinux.ExecInLinux(username, password, host, port, uploadjar_command);
		
		/* jarļϴһȡ
		 connectionLinux.putFile(username, password, hostname, port,
		 dataMap.get("JarUrl"), "/lib/knowlegen/jar");
		 * String jarUrl = dataMap.get("JarUrl"); File file = new
		 * File(jarUrl.trim()); String jarName = file.getName(); SCPClient
		 * scpClient = connection.createSCPClient(); scpClient.put(jarUrl,
		 * "/home/lib/" + jarName); Session session = connection.openSession();
		 * InputStream stdout = new StreamGobbler(session.getStdout());
		 * BufferedReader br = new BufferedReader(new
		 * InputStreamReader(stdout)); while (true) { String line =
		 * br.readLine(); if (line == null) { logger.info("Զ̷Ϣ:"); break;
		 * } logger.info("Զ̷Ϣ: " + line); } // ˳״̬
		 * System.out.println("ExitCode: " + session.getExitStatus());
		 */

		// TODO 3ִSparkִSpark
		// ִеspark
		logger.info("ִSparkִSpark...");

		/*
		 * 2017122016:21:40
		 *  shell  command
		 */
		
		System.out.println("---ִеspark");
		
		String command ;
				/*"spark-submit --class " + dataMap.get("Class")
				
				 * 2017122115:39:50
				 * SparkUrl ʹ
				 
		
				//+ " --master " + dataMap.get("SparkMasterUrl")
				+ " --master " + dataMap.get("SparkUrl")
				+ " --name " + dataMap.get("CName") 
				+ " --executor-cores " + dataMap.get("ExecutorCores")
				+ " --executor-memory " + dataMap.get("ExecutorMemory") +"G"
				+ " --driver-memory " + dataMap.get("DirverMemory") + "G"
				+ " --conf spark.serializer=" + dataMap.get("Serializer")
				+ " --conf spark.executor.heartbeatInterval=" + dataMap.get("Heartbeat") + "s" 
				+ " /home/" + username + "/jar/" + filename  
				+ " " + dataMap.get("HDFSInputURL") 
				+ " " + dataMap.get("HDFSOutputURL(RE)") 
				+ " " + dataMap.get("HDFSOutputURL(CO)");*/
		
		/*
		 * 20181510:59:38
		 * Ӳж
		 */
		StringBuilder builder = new StringBuilder();
		builder.append("spark-submit --class " + dataMap.get("Class") + " --master " + dataMap.get("SparkUrl"));
		
		/*
		 * 20181514:24:02
		 *  --name ʱȡ
		 */
		/*if(dataMap.get("CName").length()>0){
			builder.append(" --name " + dataMap.get("CName"));
		}*/
		
		if(dataMap.get("ExecutorCores").length()>0){
			builder.append(" --executor-cores " + dataMap.get("ExecutorCores"));
		}
		if(dataMap.get("ExecutorMemory").length()>0){
			builder.append(" --executor-memory " + dataMap.get("ExecutorMemory") +"G");
		}
		if(dataMap.get("DirverMemory").length()>0){
			builder.append(" --driver-memory " + dataMap.get("DirverMemory") + "G");
		}
		
		if(dataMap.get("Serializer").length()>0){
			builder.append(" --conf spark.serializer=" + dataMap.get("Serializer"));
		}
		if (dataMap.get("Heartbeat").length()>0) {
			builder.append(" --conf spark.executor.heartbeatInterval=" + dataMap.get("Heartbeat") + "s");
		}
		
		builder.append(" /home/" + username + "/jar/" + filename);
		
		/*
		 * TODO ޸Ϊڶ
		 * 20181517:54:27
		 * 
		 * ޸Ϊ
		 * builder.append(" " + dataMap.get("Input(2)"));
		 */
		
		//builder.append(" " + dataMap.get("SparkUrl"));//Ϊ
		builder.append(" " + dataMap.get("Input(2)"));
		
		builder.append(
				" " + dataMap.get("HDFSInputURL") //
				+ " " + dataMap.get("HDFSOutputURL(RE)") // 
				+ " " + dataMap.get("HDFSOutputURL(CO)")); //
		
		command = builder.toString();
		
		//String command = "spark-submit --class com.knowlegene.kw.graph.job.ActionJob --master spark://192.168.1.40:7077 --driver-memory 2G --executor-memory 30G --conf spark.serializer=org.apache.spark.serializer.KryoSerializer /home/hadoop/kw-algorithm-spark-0.0.1-SNAPSHOT.jar spark://192.168.1.40:7077 hdfs://master-116:8020/zy/init/relationship  hdfs://192.168.1.40:8020/zy/init/org  hdfs://192.168.1.40:8020/zy/init/dm2";
		
		/*
		 * 2017122714:13:49
		 * ڲsparkǷõ
		 */
//		command = "spark --version";
		
		System.out.println(command);
		
		/*
		 * 2017122016:26:58
		 * ִcommand
		 * 
		 * 2017122716:23:48
		 * 
		 * 20181510:55:50
		 * ִinfoãȡϢȡ;
		 */
		//Map<String, String> commandmap = connectionLinux.ExecInLinux(username, password, host, port, command);
		String app_id = connectionLinux.GetAppID(username, password, host, port, command);
		//connectionLinux.ExecInLinux(username, password, host, port, command);
		
		//System.out.println(commandmap);//ִĽִн洢mapС
		System.out.println("---------------application id------------------");
		System.out.println("[[[[[[[[[[[[[[[app-id:"+app_id+"]]]]]]]]]]]]]]]]]]");
		System.out.println("-----------------------------------------------");
		/*
		 * session.execCommand("spark --class " + dataMap.get("Class") +
		 * " --master " + dataMap.get("SparkMasterUrl") + " --name " +
		 * dataMap.get("CName") + " --executor-cores " +
		 * dataMap.get("ExecutorCores") + " --executor-memory " +
		 * dataMap.get("ExecutorMemory") + " --driver-memory " +
		 * dataMap.get("DirverMemory") +
		 * " --conf spark.executor.heartbeatInterval=" +
		 * dataMap.get("Heartbeat") + "s" + " " + dataMap.get("JarUrl") + " " +
		 * dataMap.get("HDFSInputURL") + " " + dataMap.get("HDFSOutputURL(RE)")
		 * + " " + dataMap.get("HDFSOutputURL(CO)"));
		 */

		// ỰĹر and ӵĹر
		// رջỰ
		/* session.close(); */
		// ر
		// connection.close();

		// the data table spec of the single output table,
		// the table will have three columns:
		/*
		 * DataColumnSpec[] allColSpecs = new DataColumnSpec[3]; allColSpecs[0]
		 * = new DataColumnSpecCreator("Column 0",
		 * StringCell.TYPE).createSpec(); allColSpecs[1] = new
		 * DataColumnSpecCreator("Column 1", DoubleCell.TYPE).createSpec();
		 * allColSpecs[2] = new DataColumnSpecCreator("Column 2",
		 * IntCell.TYPE).createSpec(); DataTableSpec outputSpec = new
		 * DataTableSpec(allColSpecs);
		 */
		// the execution context will provide us with storage capacity, in this
		// case a data container to which we will add rows sequentially
		// Note, this container can also handle arbitrary big data tables, it
		// will buffer to disc if necessary.
		/*
		 * BufferedDataContainer container =
		 * exec.createDataContainer(outputSpec);
		 */
		// let's add m_count rows to it
		/*
		 * for (int i = 0; i < m_count.getIntValue(); i++) { RowKey key = new
		 * RowKey("Row " + i); // the cells of the current row, the types of the
		 * cells must match // the column spec (see above) DataCell[] cells =
		 * new DataCell[3]; cells[0] = new StringCell("String_" + i); cells[1] =
		 * new DoubleCell(0.5 * i); cells[2] = new IntCell(i); DataRow row = new
		 * DefaultRow(key, cells); container.addRowToTable(row);
		 * 
		 * // check if the execution monitor was canceled exec.checkCanceled();
		 * exec.setProgress(i / (double)m_count.getIntValue(), "Adding row " +
		 * i); }
		 */
		// once we are done, we close the container and return its table
		/* container.close(); */
		/* BufferedDataTable out = container.getTable(); */
		/* return new BufferedDataTable[] { out }; */
		
		/*
		 * 2017122016:34:17
		 * table
		 * 
		 * 2017122115:45:52
		 * ޸ĳ 5
		 */
		DataColumnSpec[] allColSpecs = new DataColumnSpec[6];
		allColSpecs[0] = new DataColumnSpecCreator("Command", StringCell.TYPE).createSpec();
		allColSpecs[1] = new DataColumnSpecCreator("Info", StringCell.TYPE).createSpec();
		allColSpecs[2] = new DataColumnSpecCreator("SparkUrl", StringCell.TYPE).createSpec();
		allColSpecs[3] = new DataColumnSpecCreator("Username", StringCell.TYPE).createSpec();
		allColSpecs[4] = new DataColumnSpecCreator("Password", StringCell.TYPE).createSpec();
		// TODO ύһڻȡ˿
		allColSpecs[5] = new DataColumnSpecCreator("OUTPUT", StringCell.TYPE).createSpec();
		
		/*
		 * 2017122115:45:16
		 * SparkUrlԽ
		 */
		//allColSpecs[5] = new DataColumnSpecCreator("MasterUrl", StringCell.TYPE).createSpec();
		
		/*
		 * 2017122109:51:56
		 * name
		 * 
		 * 2017122115:45:52
		 * ޸ĳ 5
		 * cell[2] ޸ΪSparkUrl
		 */
		//allColSpecs[6] = new DataColumnSpecCreator("Name", StringCell.TYPE).createSpec();
		
		DataTableSpec outputSpec = new DataTableSpec(allColSpecs);
		
		BufferedDataContainer container = exec.createDataContainer(outputSpec);
		
		RowKey key_01 = new RowKey("Info " + 1);
		
		DataCell[] cells = new DataCell[6];
		cells[0] = new StringCell("");
		/*
		 * 20181510:54:40
		 * ִнinfoܹȡ
		 */
		//cells[1] = new StringCell(commandmap.get(command));
		/*
		 * TODO infoapp-id
		 * 201811114:25:05
		 */
		cells[1] = new StringCell(app_id);
		//cells[2] = new StringCell(hostUrl);
		cells[2] = new StringCell(dataMap.get("SparkUrl"));
		cells[3] = new StringCell(username);
		cells[4] = new StringCell(password);
		//TODO һ
		cells[5] = new StringCell(dataMap.get("HDFSOutputURL(CO)"));
		
		/*
		 * 2017122115:45:16
		 * SparkUrlԽ
		 */
		//cells[5] = new StringCell(dataMap.get("SparkMasterUrl"));
		
		/*
		 * 2017122109:53:07
		 * name
		 */
		//cells[6] = new StringCell(dataMap.get("CName"));
		
		DataRow row = new DefaultRow(key_01, cells);
		
		container.addRowToTable(row);
		
		container.close();
		
		BufferedDataTable out = container.getTable();
		
		connectionLinux.close();
		
		// TODO ΪջᱨǷطurlһڵڲѯinfo
		return new BufferedDataTable[] {out};
	}

	/**
	 * {@inheritDoc}
	 * ɾexecuteеģͣԼload/saveInternalsдݡ
	 */
	@Override
	protected void reset() {
		// Models build during execute are cleared here.
		// Also data handled in load/saveInternals will be erased here.
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected DataTableSpec[] configure(final DataTableSpec[] inSpecs) throws InvalidSettingsException {

		// table structure, and the incoming types are feasible for the node
		// to execute. If the node can execute in its current state return
		// the spec of its output data table(s) (if you can, otherwise an array
		// with null elements), or throw an exception with a useful user message

		return new DataTableSpec[] { null };
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void saveSettingsTo(final NodeSettingsWO settings) {

		// TODO save user settings to the config object.

		// m_count.saveSettingsTo(settings);

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void loadValidatedSettingsFrom(final NodeSettingsRO settings) throws InvalidSettingsException {

		// TODO load (valid) settings from the config object.
		// It can be safely assumed that the settings are valided by the
		// method below.

		// m_count.loadSettingsFrom(settings);

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void validateSettings(final NodeSettingsRO settings) throws InvalidSettingsException {

		// TODO check if the settings could be applied to our model
		// e.g. if the count is in a certain range (which is ensured by the
		// SettingsModel).
		// Do not actually set any values of any member variables.

		// m_count.validateSettings(settings);

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void loadInternals(final File internDir, final ExecutionMonitor exec)
			throws IOException, CanceledExecutionException {

		// Everything handed to output ports is loaded automatically (data
		// returned by the execute method, models loaded in loadModelContent,
		// and user settings set through loadSettingsFrom - is all taken care
		// of). Load here only the other internals that need to be restored
		// (e.g. data used by the views).

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void saveInternals(final File internDir, final ExecutionMonitor exec)
			throws IOException, CanceledExecutionException {

		// Everything written to output ports is saved automatically (data
		// returned by the execute method, models saved in the saveModelContent,
		// and user settings saved through saveSettingsTo - is all taken care
		// of). Save here only the other internals that need to be preserved
		// (e.g. data used by the views).

	}

	/*
	 * public static String getHost(String url) { //ʹʽˣ String re =
	 * "((http|ftp|https)://)(([a-zA-Z0-9._-]+)|([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}))(([a-zA-Z]{2,6})|(:[0-9]{1,4})?)";
	 * String str = ""; // ʽ Pattern pattern = Pattern.compile(re); //
	 * ԴСдд // Pattern pat = Pattern.compile(regEx,
	 * Pattern.CASE_INSENSITIVE); Matcher matcher = pattern.matcher(url);
	 * //url==http://127.0.0.1:9040www.baidu.comģʽʾƥ if
	 * (matcher.matches()) { str = url; } else { String[] split2 =
	 * url.split(re); if (split2.length > 1) { String substring =
	 * url.substring(0, url.length() - split2[1].length()); str = substring; }
	 * else { str = split2[0]; } } return str; } public static String
	 * getPort(String url) { //ʹʽˣ String re =
	 * "((http|ftp|https)://)(([a-zA-Z0-9._-]+)|([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}))(([a-zA-Z]{2,6})|(:[0-9]{1,4})?)";
	 * String str = ""; // ʽ Pattern pattern = Pattern.compile(re); //
	 * ԴСдд // Pattern pat = Pattern.compile(regEx,
	 * Pattern.CASE_INSENSITIVE); Matcher matcher = pattern.matcher(url);
	 * //url==http://127.0.0.1:9040www.baidu.comģʽʾƥ if
	 * (matcher.matches()) { str = url; } else { String[] split2 =
	 * url.split(re); if (split2.length > 1) { String substring =
	 * url.substring(0, url.length() - split2[1].length()); str = substring; }
	 * else { str = split2[0]; } } return str; }
	 */

	
}
