package org.lyj.test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;

import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelExec;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import com.jcraft.jsch.SftpException;

public class ConnectionTest {

	private static Session session;
	
	public boolean ConnectionLinuxTest(String username,String password , String host,int port){
//		String username = "root";
//		String password = "root";
		
		java.util.Properties config = new java.util.Properties();  
        config.put("StrictHostKeyChecking", "no");
        
        JSch jsch = new JSch();
        
        try {
        	
			session = jsch.getSession(username, host, port);
			session.setPassword(password);
			session.setConfig(config);
			/*connect*/
			session.connect();
			System.out.println("ӳɹ");
			/*disconnect*/
			/*session.disconnect();*/
			
		} catch (JSchException e) {
			
			e.printStackTrace();
			System.out.println("ʧܣ");
			return false;
			
		}
		
        return true;
		
	}
	
	public Map<String, String> ExecInLinux(String username,String pass,String host,int port,String command){
		
		if (!ConnectionLinuxTest(username, pass, host, port)) {
			System.out.println("connect successed");
			return null;
		}
		
		Map<String, String> map = new HashMap<>();
		StringBuilder stringBuffer;
		BufferedReader reader =null;  
        Channel channel = null;
		
		stringBuffer = new StringBuilder();
		try {
			
			channel = session.openChannel("exec");
			((ChannelExec) channel).setCommand(command);
			
			channel.setInputStream(null);
			((ChannelExec) channel).setErrStream(System.err);
			
			channel.connect();
			InputStream in = channel.getInputStream();
			reader = new BufferedReader(new InputStreamReader(in));
			String buf;
			while((buf = reader.readLine()) != null){
				if (buf.contains("PID")) {
					break;
				}
				stringBuffer.append(buf.trim()).append(System.getProperty("line.separator"));
			}
			
			//------
			map.put(command, stringBuffer.toString());
			
		} catch (JSchException | IOException e) {
			e.printStackTrace();
		} finally {
			
			try {
				if (reader != null) {
					reader.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			if (channel != null) {
				channel.disconnect();
			}
			
			session.disconnect();
		}
		
		return map;
	}
	
	/*ϴļLinux*/
	public void putFile(String username,String password,String host, int port,String localUlr,String remoteUrl){
		if(!ConnectionLinuxTest(username, password, host, port)){
			System.out.println("ʧ");
		}else{
			try {
				
				Channel channelsftp = session.openChannel("sftp");
				ChannelSftp c = (ChannelSftp) channelsftp;
				channelsftp.connect();
				if(remoteUrl != null && remoteUrl.trim().length() > 0){
					
					try {
						c.mkdir(remoteUrl);
					} catch (SftpException e) {
						/*System.out.println("Ŀ¼ʧ Ѿ");*/
					}
					
				}else{
					remoteUrl = ".";
				}
				
				if(localUlr != null || localUlr.trim().length() > 0){
					c.put(localUlr,remoteUrl);
				}else{
					System.out.println("ļ·Ϊ");
				}
				
				channelsftp.disconnect();
				
			} catch (JSchException | SftpException e) {
				e.printStackTrace();
			} finally {
				
//				channelsftp.disconnect();
				session.disconnect();
			}
		}
	}
	
	/*
	 * public static void main(String[] args) {
	 * 
	 * ConnectionTest connectionTest = new ConnectionTest(); //
	 * connectionTest.ConnectionLinuxTest("root","root","192.168.1.11", 22); //
	 * System.out.println(connectionTest.ExecInLinux("root",
	 * "root","192.168.1.11", 22,"ifconfig"));
	 * 
	 * // connectionTest.putFile("root", "root","192.168.1.11", 22,
	 * "C:/Users/Administrator/Desktop/ڵ㽨/testToUpFile.txt", "/lyj_test");
	 * 
	 * }
	 */

}
